#
# CaptchaWidget by Tom 'Spanky' Kapanka
# SpankyFromBRC in irc://irc.freenode.net/plone
#

from Products.Archetypes.Widget import TypesWidget
from Products.Archetypes.Registry import registerWidget

class CaptchaWidget(TypesWidget):
    """ 
    """

    _properties = TypesWidget._properties.copy()
    _properties.update({    'macro'     : 'widget_captcha',
                            'size'      : '30',
                            'maxlength' : '30',
                         },)
                         
    def process_form(self, instance, field, form, empty_marker=None,
                     emptyReturnsMarker=False):
        """If a value was typed in the box, use this, else use the selected
        value.
        """
        name = field.getName()
        value = form.get(name, empty_marker)
        if value == '' or value == [''] and emptyReturnsMarker:
            return empty_marker
        return value, {}

registerWidget(CaptchaWidget,
                title = 'Captcha widget',
                description= ('Renders a Captcha Image and input field',),
                used_for = ('Products.Archetypes.Field.StringField',)
                )
